//----------------------------------------------------------------------//
// Sound Bubbles	fUCݒ_CAO								//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "usrfunc.h"
#include "usr_wic.h"
#include "MainForm.h"
#include "DsgnDlg.h"

//---------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TDesignDlg *DesignDlg;
//---------------------------------------------------------------------
__fastcall TDesignDlg::TDesignDlg(TComponent* AOwner)
	: TForm(AOwner)
{
	ColComboBox->Items->Text =
		"wi\r\n"
		"Ŝ̒S\r\n"
		"}EX\r\n"
		"Q1̒S\r\n"
		"Q2̒S\r\n"
		"Q3̒S\r\n"
		"Q1: ʏ펞̖A\r\n"
		"Q1: ʏ펞̗֊s\r\n"
		"Q1: ̖A\r\n"
		"Q1: ̗֊s\r\n"
		"Q2: ʏ펞̖A\r\n"
		"Q2: ʏ펞̗֊s\r\n"
		"Q2: ̖A\r\n"
		"Q2: ̗֊s\r\n"
		"Q3: ʏ펞̖A\r\n"
		"Q3: ʏ펞̗֊s\r\n"
		"Q3: ̖A\r\n"
		"Q3: ̗֊s\r\n";
}
//---------------------------------------------------------------------------
void __fastcall TDesignDlg::FormShow(TObject *Sender)
{
	frmprm *fp = &SbblMainForm->FRMprm;
	BgImgEdit->Text 		= fp->bgimg_file;
	BgImgEdit->Hint			= fp->bgimg_file;
	BgImgCheckBox->Checked	= fp->enable_bgimg;
	StretchChkBox->Checked	= fp->stretch_bgimg;
	HideTbarChkBox->Checked = fp->hide_titlebar;
}

//---------------------------------------------------------------------------
//wi摜̑I
//---------------------------------------------------------------------------
void __fastcall TDesignDlg::BgImgBtnClick(TObject *Sender)
{
	frmprm *fp = &SbblMainForm->FRMprm;
	OpenPictDialog->Title  = "wi摜̑I";
	OpenPictDialog->Filter = GraphicFilter(__classid(Graphics::TBitmap))
		+ "|JPEGt@C(*.JPG)|*.JPG|PNGt@C(*.PNG)|*.PNG|GIFt@C(*.GIF)|*.GIF";
	OpenPictDialog->DefaultExt = String("BMP");
	OpenPictDialog->FileName   = EmptyStr;
	OpenPictDialog->InitialDir = ExtractFilePath(fp->bgimg_file);
	if (OpenPictDialog->Execute()) {
		if (FileExists(OpenPictDialog->FileName)) {
			BgImgCheckBox->Checked = false;
			fp->enable_bgimg	   = false;
			fp->bgimg_file		   = OpenPictDialog->FileName;
			fp->stretch_bgimg	   = StretchChkBox->Checked;
			BgImgEdit->Text 	   = fp->bgimg_file;
			BgImgEdit->Hint		   = fp->bgimg_file;
			WIC_load_image(fp->bgimg_file, fp->bgimg);
			BgImgCheckBox->Checked = true;
			fp->enable_bgimg	   = true;
			SbblMainForm->Repaint();
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TDesignDlg::BgImgCheckBoxClick(TObject *Sender)
{
	SbblMainForm->FRMprm.enable_bgimg = BgImgCheckBox->Checked;
	SbblMainForm->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TDesignDlg::StretchChkBoxClick(TObject *Sender)
{
	SbblMainForm->FRMprm.stretch_bgimg = StretchChkBox->Checked;
	SbblMainForm->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TDesignDlg::HideTbarChkBoxClick(TObject *Sender)
{
	SbblMainForm->FRMprm.hide_titlebar = HideTbarChkBox->Checked;
}

//---------------------------------------------------------------------------
TColor __fastcall TDesignDlg::GetColorOfIdx(int idx)
{
	TColor col = clNone;
	frmprm *fp = &SbblMainForm->FRMprm;

	switch (idx) {
	case  0: col = fp->col_background;	  break;
	case  1: col = fp->col_center_ring;   break;
	case  2: col = fp->col_mouse_ring;	  break;
	case  3: col = fp->col_group_ring[0]; break;
	case  4: col = fp->col_group_ring[1]; break;
	case  5: col = fp->col_group_ring[2]; break;
	case  6: col = fp->col_nrm_brs[0];	  break;
	case  7: col = fp->col_nrm_pen[0];	  break;
	case  8: col = fp->col_act_brs[0];	  break;
	case  9: col = fp->col_act_pen[0];	  break;
	case 10: col = fp->col_nrm_brs[1];	  break;
	case 11: col = fp->col_nrm_pen[1];	  break;
	case 12: col = fp->col_act_brs[1];	  break;
	case 13: col = fp->col_act_pen[1];	  break;
	case 14: col = fp->col_nrm_brs[2];	  break;
	case 15: col = fp->col_nrm_pen[2];	  break;
	case 16: col = fp->col_act_brs[2];	  break;
	case 17: col = fp->col_act_pen[2];	  break;
	}

	return col;
}

//---------------------------------------------------------------------------
void __fastcall TDesignDlg::RefColBtnClick(TObject *Sender)
{
	int idx = ColComboBox->ItemIndex;
	if (idx!=-1) {
		ColorDialog1->Color = GetColorOfIdx(idx);
		if (ColorDialog1->Execute()) {
			frmprm *fp = &SbblMainForm->FRMprm;
			switch (idx) {
			case  0:
				fp->col_background  = ColorDialog1->Color;
				SbblMainForm->Color = fp->col_background;
				break;

			case  1: fp->col_center_ring = ColorDialog1->Color; break;
			case  2: fp->col_mouse_ring  = ColorDialog1->Color; break;

			case  3:
				fp->col_group_ring[0]  = ColorDialog1->Color;
				SbblMainForm->GRing[0]->Pen->Color = fp->col_group_ring[0];
				break;
			case  4:
				fp->col_group_ring[1]  = ColorDialog1->Color;
				SbblMainForm->GRing[1]->Pen->Color = fp->col_group_ring[1];
				break;
			case  5:
				fp->col_group_ring[2]  = ColorDialog1->Color;
				SbblMainForm->GRing[2]->Pen->Color = fp->col_group_ring[2];
				break;

			case  6: fp->col_nrm_brs[0]  = ColorDialog1->Color; break;
			case  7: fp->col_nrm_pen[0]  = ColorDialog1->Color; break;
			case  8: fp->col_act_brs[0]  = ColorDialog1->Color; break;
			case  9: fp->col_act_pen[0]  = ColorDialog1->Color; break;
			case 10: fp->col_nrm_brs[1]  = ColorDialog1->Color; break;
			case 11: fp->col_nrm_pen[1]  = ColorDialog1->Color; break;
			case 12: fp->col_act_brs[1]  = ColorDialog1->Color; break;
			case 13: fp->col_act_pen[1]  = ColorDialog1->Color; break;
			case 14: fp->col_nrm_brs[2]  = ColorDialog1->Color; break;
			case 15: fp->col_nrm_pen[2]  = ColorDialog1->Color; break;
			case 16: fp->col_act_brs[2]  = ColorDialog1->Color; break;
			case 17: fp->col_act_pen[2]  = ColorDialog1->Color; break;
			}

			switch (idx) {
			case 6: case 7: case 8: case 9:
				SbblMainForm->BB[0]->set_color(
					fp->col_nrm_pen[0], fp->col_nrm_brs[0], fp->col_act_pen[0], fp->col_act_brs[0]);
				break;
			case 10: case 11: case 12: case 13:
				SbblMainForm->BB[1]->set_color(
					fp->col_nrm_pen[1], fp->col_nrm_brs[1], fp->col_act_pen[1], fp->col_act_brs[1]);
				break;
			case 14: case 15: case 16: case 17:
				SbblMainForm->BB[2]->set_color(
					fp->col_nrm_pen[2], fp->col_nrm_brs[2], fp->col_act_pen[2], fp->col_act_brs[2]);
				break;
			}
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TDesignDlg::ColListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
          TOwnerDrawState State)
{
	TListBox *lp = (TListBox *)Control;
	TCanvas  *cv = lp->Canvas;
	int yp = Rect.Top + 2;

	cv->Brush->Color = State.Contains(odSelected)? clHighlight : clWindow;
	cv->Font->Color  = State.Contains(odSelected)? clHighlightText : clWindowText;
	cv->FillRect(Rect);
	cv->TextOut(Rect.Left+34, yp, lp->Items->Strings[Index]);

	//J[
	cv->Brush->Color = GetColorOfIdx(Index);
	TRect rc = Rect;  rc.Right = rc.Left + 30;
	cv->FillRect(rc);
}
//---------------------------------------------------------------------------
void __fastcall TDesignDlg::ColComboBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
          TOwnerDrawState State)
{
	TComboBox *cp = (TComboBox *)Control;
	TCanvas  *cv = cp->Canvas;
	int yp = Rect.Top + 2;

	cv->Brush->Color = State.Contains(odSelected)? clHighlight : clWindow;
	cv->Font->Color  = State.Contains(odSelected)? clHighlightText : clWindowText;
	cv->FillRect(Rect);
	cv->TextOut(Rect.Left+34, yp, cp->Items->Strings[Index]);

	//J[
	cv->Brush->Color = GetColorOfIdx(Index);
	TRect rc = Rect;  rc.Right = rc.Left + 30;
	cv->FillRect(rc);
}
//---------------------------------------------------------------------------

