//----------------------------------------------------------------------//
// Sound Bubbles	fUCݒ_CAO								//
//																		// 
//----------------------------------------------------------------------//
#ifndef DsgnDlgH
#define DsgnDlgH

//----------------------------------------------------------------------------
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>

//----------------------------------------------------------------------------
class TDesignDlg : public TForm
{
__published:
	TButton *BgImgBtn;
	TButton *RefColBtn;
	TCheckBox *BgImgCheckBox;
	TCheckBox *HideTbarChkBox;
	TCheckBox *StretchChkBox;
	TColorDialog *ColorDialog1;
	TEdit *BgImgEdit;
	TGroupBox *GroupBox1;
	TGroupBox *GroupBox2;
	TOpenPictureDialog *OpenPictDialog;
	TComboBox *ColComboBox;

	void __fastcall BgImgBtnClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall StretchChkBoxClick(TObject *Sender);
	void __fastcall HideTbarChkBoxClick(TObject *Sender);
	void __fastcall BgImgCheckBoxClick(TObject *Sender);
	void __fastcall RefColBtnClick(TObject *Sender);
	void __fastcall ColListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
          TOwnerDrawState State);
	void __fastcall ColComboBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
          TOwnerDrawState State);

private:
	TColor __fastcall GetColorOfIdx(int idx);

public:
	virtual __fastcall TDesignDlg(TComponent* AOwner);
};
//----------------------------------------------------------------------------
extern PACKAGE TDesignDlg *DesignDlg;
//----------------------------------------------------------------------------
#endif
