//----------------------------------------------------------------------//
// Sound Bubbles	CtH[										//
//																		//
//----------------------------------------------------------------------//
#ifndef MainFormH
#define MainFormH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <inifiles.hpp>

#include "bubbles.h"

//---------------------------------------------------------------------------
#define MAX_BB_GROUP 3

//---------------------------------------------------------------------------
struct frmprm {
	TColor col_background;
	TColor col_center_ring;
	TColor col_mouse_ring;
	TColor col_group_ring[3];
	TColor col_nrm_brs[MAX_BB_GROUP];
	TColor col_nrm_pen[MAX_BB_GROUP];
	TColor col_act_brs[MAX_BB_GROUP];
	TColor col_act_pen[MAX_BB_GROUP];

	Graphics::TBitmap *bgimg; 	//wiC[W
	UnicodeString bgimg_file;
	bool enable_bgimg;
	bool stretch_bgimg;

	bool hide_titlebar;
};

//---------------------------------------------------------------------------
class TSbblMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TMainMenu *MainMenu1;
	TMenuItem *AboutItem;
	TMenuItem *ContentsItem;
	TMenuItem *DesignItem;
	TMenuItem *ExitItem;
	TMenuItem *File1;
	TMenuItem *Help1;
	TMenuItem *MidiRecItem;
	TMenuItem *Option1;
	TMenuItem *ParameterItem;
	TMenuItem *PopDesignItem;
	TMenuItem *PopExitItem;
	TMenuItem *PopMidiRecItem;
	TMenuItem *PopParameterItem;
	TMenuItem *PopRestoreItem;
	TMenuItem *PopSoundItem;
	TMenuItem *Sep_p_1;
	TMenuItem *Sep_p_2;
	TMenuItem *SoundItem;
	TMenuItem *Tool1;
	TPopupMenu *PopupMenu1;
	TTimer *Timer1;

	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall SoundItemClick(TObject *Sender);
	void __fastcall ParameterItemClick(TObject *Sender);
	void __fastcall AboutItemClick(TObject *Sender);
	void __fastcall ContentsItemClick(TObject *Sender);
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall ExitItemClick(TObject *Sender);
	void __fastcall DesignItemClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall PopRestoreItemClick(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall MidiRecItemClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);

private:	// [U[錾
	void __fastcall WmGetMinMaxInfo(TWMGetMinMaxInfo &Msg);

public:		// [U[錾
	__fastcall TSbblMainForm(TComponent* Owner);

	frmprm  FRMprm;
	Bubbles *BB[MAX_BB_GROUP];

	bool MouseON;

	TShape *GRing[MAX_BB_GROUP];
	TShape *MRing;

	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_GETMINMAXINFO,TWMGetMinMaxInfo,WmGetMinMaxInfo)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TSbblMainForm *SbblMainForm;
extern bubble_prm BBprm;
//---------------------------------------------------------------------------
#endif
