//----------------------------------------------------------------------//
// Sound Bubbles	p[^ݒ_CAO							//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include "MainForm.h"
#include "PrmDlg.h"

//---------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TParamDlg *ParamDlg;

//---------------------------------------------------------------------
__fastcall TParamDlg::TParamDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TParamDlg::FormShow(TObject *Sender)
{
	VLabel1->Caption	  = UnicodeString().sprintf(_T("%4.2f"), BBprm.copyWait);
	ScrollBar1->Position  = (BBprm.copyWait+0.005)*100;
	VLabel2->Caption	  = UnicodeString().sprintf(_T("%4.2f"), BBprm.centerWait);
	ScrollBar2->Position  = (BBprm.centerWait+0.005)*100;
	VLabel3->Caption	  = UnicodeString().sprintf(_T("%4.2f"), BBprm.mouseWait);
	ScrollBar3->Position  = (BBprm.mouseWait+0.005)*100;
	VLabel4->Caption	  = UnicodeString().sprintf(_T("%4.2f"), BBprm.oppositeWait);
	ScrollBar4->Position  = (BBprm.oppositeWait+0.005)*100;
	VLabel5->Caption	  = IntToStr((int)BBprm.min_speed);
	ScrollBar5->Position  = BBprm.min_speed;
	VLabel6->Caption	  = IntToStr((int)BBprm.max_speed);
	ScrollBar6->Position  = BBprm.max_speed;
	VLabel7->Caption	  = UnicodeString().sprintf(_T("%4.2f"), BBprm.acceleration);
	ScrollBar7->Position  = (BBprm.acceleration+0.005)*100;
	VLabel8->Caption	  = IntToStr((int)BBprm.best_dist);
	ScrollBar8->Position  = BBprm.best_dist;
	VLabel9->Caption	  = IntToStr((int)BBprm.tone_dist);
	ScrollBar9->Position  = BBprm.tone_dist;
	VLabel10->Caption	  = IntToStr(BBprm.size);
	ScrollBar10->Position = BBprm.size;
	VLabel11->Caption	  = IntToStr(BBprm.count);
	ScrollBar11->Max	  = MAX_BUBBLES;
	ScrollBar11->Position = BBprm.count;

	if (BBprm.joinV) 	  CheckBox1->State = cbChecked;
	if (BBprm.joinH) 	  CheckBox2->State = cbChecked;
	if (BBprm.front_view) CheckBox3->State = cbChecked;
}

//---------------------------------------------------------------------
void __fastcall TParamDlg::ScrollBarChange(TObject *Sender)
{
	switch (dynamic_cast<TComponent *>(Sender)->Tag) {
	case  0:
		BBprm.copyWait	 = ScrollBar1->Position/100.0;
		VLabel1->Caption = UnicodeString().sprintf(_T("%4.2f"), BBprm.copyWait);
		break;
	case  1:
		BBprm.centerWait = ScrollBar2->Position/100.0;
		VLabel2->Caption = UnicodeString().sprintf(_T("%4.2f"), BBprm.centerWait);
		break;
	case  2:
		BBprm.mouseWait  = ScrollBar3->Position/100.0;
		VLabel3->Caption = UnicodeString().sprintf(_T("%4.2f"), BBprm.mouseWait);
		break;
	case  3:
		BBprm.oppositeWait = ScrollBar4->Position/100.0;
		VLabel4->Caption   = UnicodeString().sprintf(_T("%4.2f"), BBprm.oppositeWait);
		break;
	case  4:
		BBprm.min_speed  = ScrollBar5->Position;
		VLabel5->Caption = IntToStr(ScrollBar5->Position);
		break;
	case  5:
		BBprm.max_speed  = ScrollBar6->Position;
		VLabel6->Caption = IntToStr(ScrollBar6->Position);
		break;
	case  6:
		BBprm.acceleration = ScrollBar7->Position/100.0;
		VLabel7->Caption = UnicodeString().sprintf(_T("%4.2f"), BBprm.acceleration);
		break;
	case  7:
		BBprm.best_dist  = ScrollBar8->Position;
		VLabel8->Caption = IntToStr(ScrollBar8->Position);
		break;
	case  8:
		BBprm.tone_dist  = ScrollBar9->Position;
		VLabel9->Caption = IntToStr(ScrollBar9->Position);
		break;
	case  9:
		BBprm.size = ScrollBar10->Position;
		VLabel10->Caption = IntToStr(ScrollBar10->Position);
		break;
	case 10:
		BBprm.count = ScrollBar11->Position;
		VLabel11->Caption = IntToStr(ScrollBar11->Position);
		break;
    }

	for (int i=0;i<MAX_BB_GROUP;i++) SbblMainForm->BB[i]->set_prm(&BBprm);
}
//---------------------------------------------------------------------------
void __fastcall TParamDlg::CheckBoxClick(TObject *Sender)
{
	TCheckBox *sp = dynamic_cast<TCheckBox *>(Sender);  if (sp==NULL) return;
	int v = (sp->State==cbChecked);
	switch (sp->Tag) {
	case 0: BBprm.joinV 	 = v; break;
	case 1: BBprm.joinH 	 = v; break;
	case 2: BBprm.front_view = v; break;
	}
	for (int i=0;i<MAX_BB_GROUP;i++) SbblMainForm->BB[i]->set_prm(&BBprm);
}
//---------------------------------------------------------------------------

