//----------------------------------------------------------------------//
// Sound Bubbles														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>

USEFORM("PrmDlg.cpp", ParamDlg);
USEFORM("SndDlg.cpp", SoundDlg);
USEFORM("MidRcBox.cpp", MidRecBox);
USEFORM("About.cpp", AboutBox);
USEFORM("DsgnDlg.cpp", DesignDlg);
USEFORM("MainForm.cpp", SbblMainForm);
//---------------------------------------------------------------------------
WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR, int)
{
	//~[ebNXɂdNh~
	HANDLE hMutex = ::CreateMutex(NULL,FALSE, _T("SoundBubbles_is_running"));
	if (::GetLastError()==ERROR_ALREADY_EXISTS) {
		::CloseHandle(hMutex);
		return -1;
	}

	try
	{
		Application->Initialize();
		Application->Title = "Sound-Bubbles";
		Application->CreateForm(__classid(TSbblMainForm), &SbblMainForm);
		Application->CreateForm(__classid(TSoundDlg), &SoundDlg);
		Application->CreateForm(__classid(TParamDlg), &ParamDlg);
		Application->CreateForm(__classid(TDesignDlg), &DesignDlg);
		Application->CreateForm(__classid(TMidRecBox), &MidRecBox);
		Application->CreateForm(__classid(TAboutBox), &AboutBox);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	catch (...)
	{
		try
		{
			throw Exception("");
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}

	::CloseHandle(hMutex);
	return 0;
}
//---------------------------------------------------------------------------
